//=============================================================================
//
//                                  SynergyEA
//                      **:.(`'.|`.') .:**
//
//                        Copyright  2007, Derk Wehler
//
//
//                                             $Workfile:: SynergyEA.mq4     $
//                                             $Revision:: 16                $
//                                               $Author:: Derk              $
//                                                 $Date:: 3/12/08 6:37a     $
//
//=============================================================================
#property copyright "Copyright  2007, Derk Wehler; all rights reserved"
#property link      "derkwehler@gmail.com"

#include <LibOrderReliable.mqh>
#include <LibDerksUtils.mqh>


// Input parameters
extern string	S1 						= "===== MONEY MANAGEMENT SETTINGS";
extern bool 	UseMoneyManagement 		= true;
extern bool		UseDualWinMM			= false;
extern bool		UseMartingaleMM			= false;
extern double	MartingaleMult			= 2.0;
extern double	MartMaxLossPercent		= 20.0;
extern double	TradeSizePercent 		= 5.0;	// Change to whatever percent of equity you wish to risk.
extern double	ScaleInPercent	 		= 25.0;
extern int		MaxScaleIns				= 0;
extern bool		SplitOrder				= true;
extern double	Lots 					= 0.2;
extern double	MinLots 				= 0.01;
extern double	MaxLots 				= 100.0;
extern string	S1z 					= " ";
extern string	S2 						= "===== ENTRY SETTINGS";
extern int		CheckClosedCandle		= 0;
extern bool 	UseVolatility			= 1;
extern bool 	UseRangeFactor			= 1;
extern int		OppCandlesForReEntry	= 3;
extern int		UseEntry68_32			= 0;
extern int		ReqRedYellowCombo		= 0;
extern int		UseVolExpanding			= 0;
extern double	UnlessVolWidthGT		= 0.0;
extern int		ReqEntryNearPAC			= 1;
extern string	S2a 					= "-------- Higher TF Confirmation";
extern int		TrendHTF_Minutes		= 0;
extern int		HA_CandlesAbovePAC		= 3;
extern string	S2b 					= "-------- Trading Times";
extern bool		UseTradingTimes			= false;
extern string 	Session1Start			= "99:99";
extern string 	Session1End				= "99:99";
extern string 	Session2Start			= "99:99";
extern string 	Session2End				= "99:99";
extern string 	Session3Start			= "99:99";
extern string 	Session3End				= "99:99";
extern string	S2z 					= " ";
extern string	S3 						= "===== EXIT SETTINGS";
extern int		UseSmallerOrOpp			= 0;
extern int		UseSmallerExit			= 0;
extern int		UseSentiment			= 1;
extern double	DefineSmaller			= 0.08;
extern int		UseClosedInside			= 0;
extern double	PercentProfitRequired	= 0.0;
extern int		UseTDI_ExitDir			= 0;
extern int		UseOppPAC_Trail			= 1;
extern int		OppPACforInitSL			= 0;
extern string	S3a 					= "-------- ATR Exit";
extern bool		UseATR_Exit				= true;
extern int 		ATR_Period				= 5;
extern double 	ATR_PipMult 			= 4;	// try 2.0 - 15.0
extern int 		ATR_MinPips				= 50;
extern int 		ATR_MaxPips				= 500;
extern string	S3b 					= "-------- StopLoss & TakeProfit";
extern int		StopLoss	 			= 0;
extern int		TakeProfit	 			= 20;
extern string	S3c 					= "-------- Trailing Stop";
extern int	 	TrailingType 			= 2;
extern int	 	TrailingValue 			= 20;
extern	string	s3d						= "---- Type 3 settings:";
extern int	 	FirstMove 				= 0;
extern int	 	FirstSL		 			= 0;
extern int	 	SecondMove 				= 0;
extern int	 	SecondSL	 		   	= 0;
extern int	 	ThirdMove 				= 0;
extern string	s3e						= "---- Type 7 settings:";
extern double	PSAR_Step				= 0.02;
extern double	PSAR_Max				= 0.2;
extern string	s3f						= "---- Type 8 settings:";
extern string	meHelp1					= "MaMethod:";
extern string	meHelp2					= "    0:SMA,  1:EMA,  2:SMMA,  3:LWMA";
extern string	meHelp3					= "MaApplyTo:";
extern string	meHelp4					= "    0:Close,  1:Open,  2:High,  3:Low";
extern string	meHelp5					= "    4:Median,  5:Typical,  6:Weighted";
extern int 		MA_Period				= 34;
extern int 		MA_Shift				= 0;
extern int 		MA_Method				= 1;
extern int 		MA_ApplyTo				= 0;
extern string	s3g						= "---- Type 9 settings:";
extern int		PCS_Period 				= 9;
extern double	PCS_Risk 				= 0.3;
extern string	S3z 					= " ";
extern string	S4 						= "===== EA SETTINGS";
extern string	S4a 					= "-------- Other Settings";
extern bool		HandleExitsOnly			= false;
extern bool		UseAlert				= false;
extern bool		UseEmail				= false;
extern string	S4b 					= "-------- General EA";
extern int		Slippage				= 3;
extern int		MagicSeed				= 118000;
extern string	ExpertName				= "SynergyEA";
extern int		DebugLevel 				= 2;


int 	MagicNumber;
double 	LotsMM, LastLots;
double	Spread;
int		ScaleIns = 0;
int		AdjStopLoss;
bool	OkToAddPositions = true;
bool	HA_ValuesAcquired = false;
bool	TDI_ValuesAcquired = false;
bool	PAC_ValuesAcquired = false;
double	MinVolatility, MinRangeFactor;
int		LastTradeDir, LastTicketNum;
int		CurTradeDir;
int		NumOpenL, NumOpenS;

bool CandleAnnounced;
bool NewCandle;

// Indicator values
double	HA_Open_0, HA_Close_0;
double 	HA_Open_1, HA_Close_1;
double 	HA_Open_2, HA_Close_2;
double	HA_DM0_2, HA_DM1_2;
double	BlueH_0, Yellow_0, BlueL_0, Green_0, Red_0;
double	BlueH_1, Yellow_1, BlueL_1, Green_1, Red_1, Red_2;
double	PAC_Hi_0, PAC_Lo_0;
double	PAC_Hi_1, PAC_Lo_1;
double	PAC_Hi_2, PAC_Lo_2;
int		MA_TrendSum;
string	ExitReason;

//=============================================================================
//	expert initialization function
//=============================================================================
int init()
{
	// Set up magic numbers:
	if (HandleExitsOnly)
		MagicNumber = 0;
	else
	    MagicNumber = MagicSeed + SymbolConst2Val(Symbol())*100 + TimeFrameConst2Val(Period());
	DU_SetErrorLevel(DebugLevel);

	MinLots = MathMax(MinLots, MarketInfo(Symbol(), MODE_MINLOT));
	MaxLots = MathMin(MaxLots, MarketInfo(Symbol(), MODE_MAXLOT));
	
	// Retreive global settings
	LastTradeDir = -1;
	if (GlobalVariableCheck("QRSX_LastTradeDir"))
		LastTradeDir = GlobalVariableGet("QRSX_LastTradeDir");
		
	LastTicketNum = -1;
	if (GlobalVariableCheck("QRSX_LastTicketNum"))
		LastTicketNum = GlobalVariableGet("QRSX_LastTicketNum");
		
	LastLots = -1;
	if (GlobalVariableCheck("QRSX_LastLots"))
		LastLots = GlobalVariableGet("QRSX_LastLots");

	CandleAnnounced = false;
	
	// Make sure TrendHTF_Minutes has valid value
	switch(TrendHTF_Minutes)
	{
		case 0:
		case PERIOD_M5:
		case PERIOD_M15:
		case PERIOD_M30:
		case PERIOD_H1:
		case PERIOD_H4:
		case PERIOD_D1:
		case PERIOD_W1:
		case PERIOD_MN1:
			break;
		default:
			Alert("TrendHTF_Minutes set to invalid value (" + TrendHTF_Minutes + ").  Expert will not run.");
			return(0);
	}
	
	// And make sure HA_CandlesAbovePAC is greater than zero if enabled
	if (TrendHTF_Minutes > 0  &&  HA_CandlesAbovePAC <= 0)
	{
		Alert("HA_CandlesAbovePAC must be greater than zero.  Expert will not run.");
		return(0);
	}
	
	// Test to see whether we can use DM_Volatility & DM_RangeFactor
	// If test calls return zero, then indicators are not present,
	// and thus cannot be used.
	double vol = iCustom(NULL, 0, "DM_Volatility", 0, 0);
	if (vol == 0)
		UseVolatility = 0;
	double rf = iCustom(NULL, 0, "DM_RangeFactor", 0, 0);
	if (rf == 0)
		UseRangeFactor = 0;
	
	// Set up default RangeFactor and Volatility levels
	switch(Period())
	{
		case PERIOD_M1:
			MinVolatility = 1.0;
			MinRangeFactor = 0.01;
			break;
		case PERIOD_M5:
			MinVolatility = 2.0;
			MinRangeFactor = 0.02;
			break;
		case PERIOD_M15:
			MinVolatility = 4.0;
			MinRangeFactor = 0.04;
			break;
		case PERIOD_M30:
			MinVolatility = 6.0;
			MinRangeFactor = 0.06;
			break;
		case PERIOD_H1:
			MinVolatility = 8.0;
			MinRangeFactor = 0.08;
			break;
		case PERIOD_H4:
			MinVolatility = 14.0;
			MinRangeFactor = 0.14;
			break;
		case PERIOD_D1:
		default:
			MinVolatility = 50.0;
			MinRangeFactor = 0.4;
			break;
	}
	
	// Volatility depends on Digits
	MinVolatility *= Point;
	
	// Set trail params	
	SetParabolicParams(PSAR_Step, PSAR_Max);
	SetMovingAverageParams(MA_Period, MA_Shift, MA_Method, MA_ApplyTo); 
	SetPriceChannelStopParams(PCS_Period, PCS_Risk);
	
	return (0);
}
  

//=============================================================================
//	expert deinitialization function
//=============================================================================
int deinit()
{
	return (0);
}


void SetAdjustedStoplossValue(int cmd)
{
   	string fn = "SetAdjustedStoplossValue()";

	AdjStopLoss = StopLoss;
	
	if (OppPACforInitSL == 0)
		return;
		
	AcquirePAC_Values();

	// Calculate initial stoploss for Price Action Channel trail
	if (cmd == OP_BUY)
	{
		if (UseOppPAC_Trail == 1)
			AdjStopLoss = (Ask - (PAC_Lo_0 - Spread)) / Point;
	}
	else if (cmd == OP_SELL)
	{
		if (UseOppPAC_Trail == 1)
			AdjStopLoss = ((PAC_Hi_0 + Spread) - Bid) / Point;
	}
}


//=============================================================================
//
// PURPOSE:
//     Calculate the number of lots to trade.
//
// PARAMETERS:
//	   magic: The magic number used to trade (used by DualWin system only)
//
// RETURN VALUE:
//     The number of lots to trade
//
//=============================================================================
double CalcLots(int magic)
{
   	string fn = "GetCandleSmallerOrOpposite()";

	double maxMartingaleLots;
	double lots = Lots;

	if (UseMoneyManagement)
	{
		lots = CalcLotsGivenRisk(TradeSizePercent, MinLots, MaxLots, AdjStopLoss);
	}

	if (UseDualWinMM)
	{
		if (TakeProfit == 0)
			Alert("ERROR!! : Attempt to use DualWin MM system with zero TP");
		else
			lots = GetDualWinLots(lots, magic, TakeProfit);
	}

	if (UseMartingaleMM)
	{
		maxMartingaleLots = CalcLotsGivenRisk(MartMaxLossPercent, MinLots, MaxLots, AdjStopLoss);
		lots = GetMartingaleLots(magic, lots, MaxLots, MartingaleMult);
		
		// If SplitOrder is enabled, then we assume it has been enabled from previous trade(s)
		// If the last trade was a loss, GetMartingaleLots will return a number based on only 
		// the last trade, where as actually it was split and therefore then number of lots 
		// should be doubled (& will subsequently be split again when order placed).
		if (SplitOrder)
			lots *= 2.0;
		
		// Never bet more than user is prepared to lose, regardless
		lots = MathMin(lots, maxMartingaleLots);
	}
	
	return(lots);
}


//=============================================================================
//
// PURPOSE:
//     Check whether to exit positions, based on ATR Indicator
//
//=============================================================================
int CheckExitOnATR()
{ 
   	string fn = "CheckExitOnATR()";

	int 	i, pipsProfit;
	int		openPos  = NumOpenPositions(MagicNumber, OP_BOTH);
	double 	pipCount = (ATR_PipMult/Point) * (iATR(NULL, 0, ATR_Period, 0));
	
	pipCount = MathMax(pipCount, ATR_MinPips);
	pipCount = MathMin(pipCount, ATR_MaxPips);

	for (i=0; i < openPos; i++)
	{
		OrderSelect(i, SELECT_BY_POS);
		if (OrderType() == OP_SELL)
			pipsProfit = (OrderOpenPrice() - Ask) / Point; 
		else 
			pipsProfit = (Bid - OrderOpenPrice()) / Point; 

		if (pipsProfit > pipCount)
		{
			return(OrderType());
		}
	}
	return(-1);
}


//=============================================================================
//
// PURPOSE:
//     Go through possible entry signals one by one, and short-circuit 
//     out early if any fail (more efficient for back-testing)
//
// PARAMETERS:
//	   cmd: The direction for which to check for entry (OP_BUY or OP_SELL)
//
// RETURN VALUE:
//          -1: Enter no trade at this time
//      OP_BUY: Signal entry for a long trade
//     OP_SELL: Signal entry for a short trade
//
//=============================================================================
bool CheckEntrySignals()
{
   	string fn = "CheckEntrySignals()";
   	
	int	tradeDir = -1;
	
	if (!TradingOkay())
	{
		Debug(5, fn, sp15 + "TradingOkay() ...... FAILED: No Trade");
		return(-1);
	}

	// Get the MA (PAC) direction.  Only check for a trade in this direction
	tradeDir = GetMA_Trend();
	if (tradeDir == -1) 
	{
		Debug(5, fn, sp15 + "GetMA_Trend() ...... PAC has no direction (sum == " + MA_TrendSum + "): No Trade");
		return(-1);
	}
	
	Debug(3, fn, "");
	Debug(3, fn, sp15 + "CHECKING FOR (" + OrderType2String(tradeDir) + ") ENTRY, BASED ON PAC DIRECTION:");
	
	if (GetHA_CloseDir() != tradeDir) 
	{
		Debug(5, fn, sp15 + "GetHA_CloseDir() ...... FAILED: No Trade");
		return(-1);
	}
	Debug(3, fn, sp15 + "GetHA_CloseDir() ...... Passed");

	if (GetTDI_EntryDir() != tradeDir) 
	{
		Debug(5, fn, sp15 + "GetTDI_EntryDir() ...... FAILED: No Trade");
		return(-1);
	}
	Debug(3, fn, sp15 + "GetTDI_EntryDir() ...... Passed");

	if (ReqEntryNearPAC == 1)
	{
		if (!PriceCloseEnoughToPAC(tradeDir)) 
		{
			Debug(5, fn, sp15 + "PriceCloseEnoughToPAC() ...... FAILED: No Trade");
			return(-1);
		}
		Debug(3, fn, sp15 + "PriceCloseEnoughToPAC() ...... Passed");
	}
	
	if (TrendHTF_Minutes > 0)
	{
		if (GetTrendHigherTF() != tradeDir) 
		{
			Debug(5, fn, sp15 + "GetTrendHigherTF() ...... FAILED: No Trade");
			return(-1);
		}
		Debug(3, fn, sp15 + "GetTrendHigherTF() ...... Passed");
	}
	
	if (UseVolExpanding == 1)
	{
		if (!VolBandsExpanding()) 
		{
			Debug(5, fn, sp15 + "VolBandsExpanding() ...... FAILED: No Trade");
			return(-1);
		}
		Debug(3, fn, sp15 + "VolBandsExpanding() ...... Passed");
	}
	
	if (UseVolatility == 1)
	{
		if (!VolatilityOK())
		{
			Debug(5, fn, sp15 + "VolatilityOK() ...... FAILED: No Trade");
			return(-1);
		}
		Debug(3, fn, sp15 + "VolatilityOK() ...... Passed");
	}
	
	if (UseRangeFactor == 1)
	{
		if (!RangeFactorOk(tradeDir)) 
		{
			Debug(5, fn, sp15 + "RangeFactorOk() ...... FAILED: No Trade");
			return(-1);
		}
		Debug(3, fn, sp15 + "RangeFactorOk() ...... Passed");
	}
	
	if (InvalidReEntry(tradeDir))
	{
		Debug(5, fn, sp15 + "InvalidReEntry() ...... FAILED: No Trade");
		return(-1);
	}
	Debug(3, fn, sp15 + "InvalidReEntry() ...... Passed");
		
	Debug(2, fn, "|:|:|:|:|:|:|:|:|:|:|:|:|:|:|:|:|:|:|:|:|:|:|:|:|:|:|:|:|:|:|:|:|:|:|:|:|:|:|");
	Debug(2, fn, sp15 + "RETURNING SIGNAL TO OPEN " + OrderType2String(tradeDir) + " TRADE");
	Debug(2, fn, "|:|:|:|:|:|:|:|:|:|:|:|:|:|:|:|:|:|:|:|:|:|:|:|:|:|:|:|:|:|:|:|:|:|:|:|:|:|:|");

	// If we get to here all rules pass
	return (tradeDir);	             
}


//=============================================================================
//
// PURPOSE:
//     Go through possible exit signals one by one, and short-circuit 
//     out early if any are hit (more efficient for back-testing)
//
// PARAMETERS:
//	   cmd: The direction for which to check for exit (OP_BUY or OP_SELL)
//
// RETURN VALUE:
//     True if we should exit, false otherwise
//
//=============================================================================
bool CheckExitSignals(int cmd)
{
   	string fn = "CheckExitSignals()";

	if (UseSmallerOrOpp == 1)
		{
		if (GetCandleSmallerOrOpposite() == cmd) 
			{
			Debug(4, fn, sp15 + "GetCandleSmallerOrOpposite() ...... TRUE: Exit");
			return (true);
			}
      Debug(4, fn, sp15 + "GetCandleSmallerOrOpposite() ...... False: Wont Exit");
      }

	if (UseClosedInside == 1)
		{
		if (GetHA_ClosedInside() == true) 
			{
			Debug(4, fn, sp15 + "GetHA_ClosedInside() ...... TRUE: Exit");
			return (true);
			}
      Debug(4, fn, sp15 + "GetHA_ClosedInside() ...... False: Wont Exit");
      }


	if (UseTDI_ExitDir == 1)
		{
		if (GetTDI_ExitDir() == cmd) 
			{
			Debug(4, fn, sp15 + "GetTDI_ExitDir() ...... TRUE: Exit");
			return (true);
			}
      Debug(4, fn, sp15 + "GetTDI_ExitDir() ...... False: Wont Exit");
      }

   if (UseSentiment == 1)
		{
		if (GetSEN_ExitDir() == cmd) 
			{
			Debug(4, fn, sp15 + "GetSEN_ExitDir() ...... TRUE: Exit");
			return (true);
			}
      Debug(4, fn, sp15 + "GetSEN_ExitDir() ...... False: Wont Exit");
      }

	if (UseOppPAC_Trail == 1)
		{
		if (PriceReachedOppositePAC() == cmd) 
			{
			Debug(4, fn, sp15 + "PriceReachedOppositePAC() ...... TRUE: Exit");
			return (true);
			}
      Debug(4, fn, sp15 + "PriceReachedOppositePAC() ...... False: Wont Exit");
      }

	return (false);
}


//=============================================================================
//
// PURPOSE:
//     Enter a trade with the given parameters
//
// PARAMETERS:
//	     op: The direction to enter trade
//     lots: The percentage to use if MM is enabled
//
// RETURN VALUE:
//     The ticket number of the trade entered
//
//=============================================================================
int DoEntry(int op, double lots, int slPips, int tpPips)
{
   	string fn = "DoEntry()";

	int 	mult, ticket;
	color	clr;
	double 	price, sl, tp;

	sl = 0;
	tp = 0;
	mult = 1;
	price = Ask;
	clr = Green;
	
	if (op == OP_SELL)
	{
		mult = -1;
		price = Bid;
		clr = Red;
	}
	
	if (slPips > 0)
		sl = price - mult * slPips*Point;
	if (tpPips > 0)
		tp = price + mult * tpPips*Point;
		
	ticket = OrderSendReliable(Symbol(), op, lots, price, Slippage, sl, tp, 
								ExpertName, MagicNumber, 0, clr);
	return(ticket);
}


//=============================================================================
//
// PURPOSE:
//     Exit all trades in a given direction
//
// PARAMETERS:
//	     op: The direction to enter trade
//     lots: The percentage to use if MM is enabled
//
// RETURN VALUE:
//     true: A trdae was exited
//    false: No trade exited
//
//=============================================================================
bool DoExit(int op)
{
   	string fn = "DoExit()";

	int		cnt;
	bool	somethingClosed = false;
	color	clr;
	double 	price, sl, tp;
    
	if (op != OP_BUY && op != OP_SELL)
		return(false);
	Debug(5, fn, sp15 + "Exit Operation");	
	for (cnt=OrdersTotal()-1; cnt >= 0; cnt--)
	{
		OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
		//if (OrderSymbol() != Symbol() || 
	//		OrderMagicNumber() != MagicNumber || 
	//		OrderType() != op) 
	//		continue;
		
		price = Bid;
		clr = Green;
	
		if (op == OP_SELL)
		{
			price = Ask;
			clr = Red;
		}
	
		if (OrderCloseReliable(OrderTicket(), OrderLots(), price, Slippage, clr))
			somethingClosed = true;
	}
   return(somethingClosed);
}


void DoAlert(string str)
{
	if (UseAlert)
		Alert(str);

	if (UseEmail)
		SendMail("SynergyInd", str);
}


///////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////    INIDICATOR VALUE ACQUISITION FUNCTIONS    //////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////
void AcquireHA_Values() 
{
   	string fn = "AcquireHA_Values()";

	if (HA_ValuesAcquired)
		return;
		
	// Get Haiken Ashi values =========================================================================================
	// Current Candle...
	HA_Open_0 	= iCustom(NULL, 0, "HeikenAshi_DM",   2, 0); // Open
	HA_Close_0 	= iCustom(NULL, 0, "HeikenAshi_DM",   3, 0); // Close
	
	// Last Closed Candle...
	HA_Open_1 	= iCustom(NULL, 0, "HeikenAshi_DM",   2, 1); // Open
	HA_Close_1 	= iCustom(NULL, 0, "HeikenAshi_DM",   3, 1); // Close
	
	// Prev Prev Candle...
	HA_Open_2 	= iCustom(NULL, 0, "HeikenAshi_DM",   2, 2); // Open
	HA_Close_2 	= iCustom(NULL, 0, "HeikenAshi_DM",   3, 2); // Close
	
	HA_ValuesAcquired = true;
}

void AcquireTDI_Values() 
{
   	string fn = "AcquireTDI_Values()";

	if (TDI_ValuesAcquired)
		return;
		
	// Get Traders Dynamic Index values ===============================================================================
	// Current Candle...
	BlueH_0 	= iCustom(NULL, 0, "Traders_Dynamic_Index", 13, 0, 34, 2, 0, 7, 0,   1, 0);	// Blue   (H. Vol Band)
	Yellow_0 	= iCustom(NULL, 0, "Traders_Dynamic_Index", 13, 0, 34, 2, 0, 7, 0,   2, 0);	// Yellow (Market Base)
	BlueL_0 	= iCustom(NULL, 0, "Traders_Dynamic_Index", 13, 0, 34, 2, 0, 7, 0,   3, 0);	// Blue   (L. Vol Band)
	Green_0 	= iCustom(NULL, 0, "Traders_Dynamic_Index", 13, 0, 34, 2, 0, 7, 0,   4, 0);	// Green  (RSI Price)
	Red_0 		= iCustom(NULL, 0, "Traders_Dynamic_Index", 13, 0, 34, 2, 0, 7, 0,   5, 0);	// Red    (Trade Signal)
	
	// Last Closed Candle...
	BlueH_1 	= iCustom(NULL, 0, "Traders_Dynamic_Index", 13, 0, 34, 2, 0, 7, 0,   1, 1);	// Blue   (H. Vol Band)
	Yellow_1 	= iCustom(NULL, 0, "Traders_Dynamic_Index", 13, 0, 34, 2, 0, 7, 0,   2, 1);	// Yellow (Market Base)
	BlueL_1 	= iCustom(NULL, 0, "Traders_Dynamic_Index", 13, 0, 34, 2, 0, 7, 0,   3, 1);	// Blue   (L. Vol Band)
	Green_1 	= iCustom(NULL, 0, "Traders_Dynamic_Index", 13, 0, 34, 2, 0, 7, 0,   4, 1);	// Green  (RSI Price)
	Red_1 		= iCustom(NULL, 0, "Traders_Dynamic_Index", 13, 0, 34, 2, 0, 7, 0,   5, 1);	// Red    (Trade Signal)
	
	// Prev Prev Candle...
	Red_2 		= iCustom(NULL, 0, "Traders_Dynamic_Index", 13, 0, 34, 2, 0, 7, 0,   5, 2);	// Red    (Prev Prev Candle)
	
	TDI_ValuesAcquired = true;
}
	
void AcquirePAC_Values() 
{
   	string fn = "AcquirePAC_Values()";

	if (PAC_ValuesAcquired)
		return;
		
	// Get Smoothed Moving Average values =============================================================================
	PAC_Hi_0 = NormalizeDouble(iMA(NULL, 0, 5, 0, MODE_SMMA, PRICE_HIGH, 0), Digits);
	PAC_Lo_0 = NormalizeDouble(iMA(NULL, 0, 5, 0, MODE_SMMA, PRICE_LOW,  0), Digits);
	PAC_Hi_1 = NormalizeDouble(iMA(NULL, 0, 5, 0, MODE_SMMA, PRICE_HIGH, 1), Digits);
	PAC_Lo_1 = NormalizeDouble(iMA(NULL, 0, 5, 0, MODE_SMMA, PRICE_LOW,  1), Digits);
	PAC_Hi_2 = NormalizeDouble(iMA(NULL, 0, 5, 0, MODE_SMMA, PRICE_HIGH, 2), Digits);
	PAC_Lo_2 = NormalizeDouble(iMA(NULL, 0, 5, 0, MODE_SMMA, PRICE_LOW,  2), Digits);
	PAC_ValuesAcquired = true;
}


///////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////    ENTRY HELPER FUNCTIONS    //////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////
int GetMA_Trend()
{
   	string fn = "GetMA_Trend()";

	MA_TrendSum = 0;
	
	AcquirePAC_Values();

	// We are looking for the general trend here, so check 
	// whether lines are headed up or down, comparing this 
	// candle with the prev and the prev prev
	if (PAC_Hi_0 > PAC_Hi_1)	MA_TrendSum += 3;
	if (PAC_Lo_0 > PAC_Lo_1)	MA_TrendSum += 3;
	if (PAC_Hi_0 > PAC_Hi_2)	MA_TrendSum += 2;
	if (PAC_Lo_0 > PAC_Lo_2)	MA_TrendSum += 2;
	if (PAC_Hi_1 > PAC_Hi_2)	MA_TrendSum += 1;
	if (PAC_Lo_1 > PAC_Lo_2)	MA_TrendSum += 1;
		
	if (PAC_Hi_0 < PAC_Hi_1)	MA_TrendSum -= 3;
	if (PAC_Lo_0 < PAC_Lo_1)	MA_TrendSum -= 3;
	if (PAC_Hi_0 < PAC_Hi_2)	MA_TrendSum -= 2;
	if (PAC_Lo_0 < PAC_Lo_2)	MA_TrendSum -= 2;
	if (PAC_Hi_1 < PAC_Hi_2)	MA_TrendSum -= 1;
	if (PAC_Lo_1 < PAC_Lo_2)	MA_TrendSum -= 1;

	// If we have 6 out of 12, consider it to have a direction
	if (MA_TrendSum >= 6)
		return(OP_BUY);
	else if (MA_TrendSum <= -6)
		return(OP_SELL);
	else
		return(-1);
}


int GetTrendHigherTF()
{
   	string fn = "GetTrendHigherTF()";

	int i, dir;
	int retVal = -1;
	double HA_Open, HA_Close;
	double PAC_Hi, PAC_Lo;
	for (i=HA_CandlesAbovePAC-1; i <= 0 ; i++)
	{
		// Get Higher Timeframe Haiken Ashi values 
		HA_Open  = iCustom(NULL, TrendHTF_Minutes, "HeikenAshi_DM",   2, i); // Open
		HA_Close = iCustom(NULL, TrendHTF_Minutes, "HeikenAshi_DM",   3, i); // Close
	
		dir = -1;
		if (HA_Open < HA_Close) 	dir = OP_BUY;
		else 
		if (HA_Open > HA_Close)		dir = OP_SELL;

		if (dir != -1)
		{
			// Initialize retVal with dir of candle #(CandlesAbovePAC-1)
			if (retVal == -1)
				retVal = dir;

			// If any other candle dir's don't match, we have no trend
			else if (retVal != dir)
				return(-1);
		}
		
		PAC_Hi = NormalizeDouble(iMA(NULL, TrendHTF_Minutes, 5, 0, MODE_SMMA, PRICE_HIGH, i), Digits);
		PAC_Lo = NormalizeDouble(iMA(NULL, TrendHTF_Minutes, 5, 0, MODE_SMMA, PRICE_LOW,  i), Digits);
		if (retVal == OP_BUY)
		{
			if (HA_Close <= PAC_Hi)
				return(-1);
		}
		else if (retVal == OP_SELL)
		{
			if (HA_Close >= PAC_Lo)
				return(-1);
		}
	}
	return(retVal);
}


int GetHA_CloseDir()
{
   	string fn = "GetHA_CloseDir()";

	AcquireHA_Values();
	AcquirePAC_Values();
	
	if (CheckClosedCandle == 1)
	{
		if (HA_Close_1 > HA_Open_1 && HA_Close_1 > PAC_Hi_1)
			return(OP_BUY);
		else 
		if (HA_Close_1 < HA_Open_1 && HA_Close_1 < PAC_Lo_1)
			return(OP_SELL);
	}
	else
	{
		if (HA_Close_0 > HA_Open_0 && HA_Close_0 > PAC_Hi_0)
			return(OP_BUY);
		else 
		if (HA_Close_0 < HA_Open_0 && HA_Close_0 < PAC_Lo_0)
			return(OP_SELL);
	}
	return(-1);
}


bool VolBandsExpanding()
{
   	string fn = "VolBandsExpanding";

	AcquireTDI_Values();

	if (BlueH_0 - BlueL_0 > BlueH_1 - BlueL_1)
	{
		Debug(6, fn, "");
		Debug(6, fn, sp15 + "BlueH_0: " + BlueH_0 + ", BlueL_0: " + BlueL_0 + "    BlueH_1: " + BlueH_1 + ", BlueL_1: " + BlueL_1);
		Debug(6, fn, sp15 + "Volume EXPANDING (" + (BlueH_0 - BlueL_0) + " vs. prev: " + (BlueH_1 - BlueL_1) + ")");
		return(true);
	}
	if (UnlessVolWidthGT != 0 && (BlueH_0 - BlueL_0) > UnlessVolWidthGT)
	{
		Debug(6, fn, sp15 + "Volume NOT expanding (" + (BlueH_0 - BlueL_0) + " vs. prev: " + (BlueH_1 - BlueL_1) + "), but still greater than " + UnlessVolWidthGT);
		return(true);
	}
	return(false);
}


int GetTDI_EntryDir()
{
   	string fn = "GetTDI_EntryDir()";

	AcquireTDI_Values();

	if (Green_0 > 50.0 && 
		(Green_0 < 68.0  || !UseEntry68_32) && 
		(Green_0 > Yellow_0 && Green_0 > Red_0))  
		return(OP_BUY);
	else 
	if (Green_0 < 50.0 && 
		(Green_0 > 32.0 || !UseEntry68_32) && 
		(Green_0 < Yellow_0 && Green_0 < Red_0)) 
		return(OP_SELL);
		
	return(-1);
}


bool PriceCloseEnoughToPAC(int cmd)
{
   	string fn = "PriceCloseEnoughToPAC()";

	AcquirePAC_Values();
	double PAC_Dist = PAC_Hi_0 - PAC_Lo_0;
	
	if (cmd == OP_BUY)
	{
		if (Ask - PAC_Hi_0 > PAC_Dist)
			return(false);
	}
	else if (cmd == OP_SELL)
	{
		if (PAC_Lo_0 - Bid > PAC_Dist)
			return(false);
	}
	return(true);
}


bool VolatilityOK()
{
   	string fn = "VolatilityOK()";

	double vol = iCustom(NULL, 0, "DM_Volatility", 0, 0);
	
	if (vol > MinVolatility)
		return(true);

	return(false);
}


bool RangeFactorOk(int op)
{
   	string fn = "RangeFactorOk()";

	double rf = iCustom(NULL, 0, "DM_RangeFactor", 0, 0);
	
	if (rf > MinRangeFactor && op == OP_BUY)
		return(true);

	if (rf < MinRangeFactor * (-1.0) && op == OP_SELL)
		return(true);

	return(false);
}


bool InvalidReEntry(int cmd)
{
   	string fn = "InvalidReEntry()";

	double HA_open, HA_close;
	
	// Don't check if there is no "last trade" yet
	if (LastTradeDir == -1  ||  LastTicketNum == -1)
		return(false);
		
	// Only check if we're trying to go the same dir as lsat trade
	if (LastTradeDir != cmd  ||  OppCandlesForReEntry == 0)
		return(false);
	
	// Get the shift value of the candle that begun the last trade
	if (!OrderSelect(LastTicketNum, SELECT_BY_TICKET, MODE_HISTORY))
	{
		Debug(1, fn, "");
		Debug(1, fn, "Unable to select ticket number #" + LastTicketNum + " from historical trades");
	}

	int 	i, dir;
	int 	consecutiveOppHAs = 0;
	int 	sh = iBarShift(NULL, 0, OrderOpenTime());
	bool	tradeProhibited = true;
	
	for (i=sh; i > 0; i--)
	{
		// Prev Prev Candle...
		HA_open  = iCustom(NULL, 0, "HeikenAshi_DM",   2, i); // Open
		HA_close = iCustom(NULL, 0, "HeikenAshi_DM",   3, i); // Close
	
		dir = -1;
		if (HA_open < HA_close)	dir = OP_BUY;
		else 
		if (HA_open > HA_close)	dir = OP_SELL;
		
		if (dir != cmd)
		{
			consecutiveOppHAs++;
			if (consecutiveOppHAs >= OppCandlesForReEntry)
			{
				tradeProhibited = false;
				break;
			}
		}
		else
			consecutiveOppHAs = 0;
	}
	
	if (tradeProhibited  &&  NewCandle)
	{
		Debug(2, fn, "");
		Debug(2, fn, "=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=");
		Debug(2, fn, "  WE HAVE NOT HAD ENOUGH OPP HA CANDLES TO TAKE ANOTHER " + OrderType2String(cmd) + " TRADE");
		Debug(2, fn, "=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=");
	}
	
	return(tradeProhibited);
}


///////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////    EXIT HELPER FUNCTIONS    ///////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////
int GetTDI_ExitDir()
{
   	string fn = "GetTDI_ExitDir()";

	AcquireTDI_Values();

	// Check for exiting Buy position
	if (Green_1 > 68.0 && Green_1 < BlueH_1 && Green_1 < Red_1)
	{
		ExitReason = "TDI";
		return(OP_BUY);
	}
	else 
	// Check for exiting sell position
	if (Green_1 < 32.0 && Green_1 > BlueL_1 && Green_1 > Red_1)
	{
		ExitReason = "TDI";
		return(OP_SELL);
	}
	return(-1);
}

int GetSEN_ExitDir()
{
   	string fn = "GetSEN_ExitDir()";

	AcquireTDI_Values();

	// Check for exiting Buy position
	if (Green_0 < Red_0)
	{
		ExitReason = "SEN";
		return(OP_BUY);
	}
	else 
	// Check for exiting sell position
	if (Green_0 > Red_0)
	{
		ExitReason = "SEN";
		return(OP_SELL);
	}
	return(-1);
}


bool GetHA_ClosedInside()
{
   	string fn = "GetHA_ClosedInside()";

	if (PercentProfitRequired != 0)
	{
		if (!TradesInProfit())
		{
			Debug(2, fn, "");
			Debug(2, fn, "Open trades NOT cumulatively in sufficient profit; ignoring \'Closed Inside\' check");
			return(false);
		}
	}
	
	AcquireHA_Values();
	AcquirePAC_Values();
		
	// HA_Close_1 is close price
	if (HA_Close_1 > PAC_Lo_1 && HA_Close_1 < PAC_Hi_1)
	{
		ExitReason = "CI";
		return(true);
	}
	else 
		return(false);
}


int GetCandleSmallerOrOpposite()
{
   	string fn = "GetCandleSmallerOrOpposite()";

	if (PercentProfitRequired != 0)
	{
		if(!TradesInProfit())
		{
			Debug(2, fn, "");
			Debug(2, fn, "Open trades NOT cumulatively in sufficient profit; ignoring \'Smaller/Opposite\' check");
			return(-1);
		}
	}
	
	AcquireHA_Values();
		
	if (HA_Close_2 > HA_Open_2)		// 2 candles back was long
	{
		// If prev candle was short, return OP_BUY signal to exit buy
		if (HA_Close_1 < HA_Open_1)
		{
			ExitReason = "OC";
			return(OP_BUY);
		}
			
		// If prev candle was "much smaller" than prev prev, then exit
		if (UseSmallerExit == 1)
		{
			if (HA_Close_1 - HA_Open_1 < (HA_Close_2 - HA_Open_2) * DefineSmaller)
			{
				ExitReason = "SC";
				return(OP_BUY);
			}
		}
	}
	else if (HA_Close_2 < HA_Open_2)	// 2 candles back was short
	{
		// If prev candle was long, return OP_SELL signal to exit sell
		if (HA_Close_1 > HA_Open_1)
		{
			ExitReason = "OC";
			return(OP_SELL);
		}
					
		// If prev candle was "much smaller" than prev prev, then exit
		if (UseSmallerExit == 1)
		{
			if (HA_Open_1 - HA_Close_1 < (HA_Open_2 - HA_Close_2) * DefineSmaller)
			{
				ExitReason = "SC";
				return(OP_SELL);
			}
		}
	}
	return(-1);
}


int PriceReachedOppositePAC()
{
   	string fn = "PriceReachedOppositePAC()";

	AcquirePAC_Values();
		
	if (Close[1] >= PAC_Hi_1 + 1)
	{
		ExitReason = "PAC";
		return(OP_SELL);	// return OP_SELL signal to exit sell
	}
	
	if (Close[1] <= PAC_Lo_1 - 1)
	{
		ExitReason = "PAC";
		return(OP_BUY);		// return OP_BUY signal to exit buy
	}
	return(-1);
}


bool TradesInProfit()
{
	string fn = "TradesInProfit";   

	int cnt;
	double totalProfit = 0;

	for (cnt=OrdersTotal()-1; cnt >= 0; cnt--)
	{
		OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
		if (OrderSymbol() != Symbol() || (OrderMagicNumber() != MagicNumber)) 
			continue;
		
		// We only want open orders; if we wanted pending too, we could use OrdersTotal()
		if (OrderType() != OP_BUY && OrderType() != OP_SELL)
			continue;

		totalProfit += OrderProfit();
	}
	
	if (totalProfit > (PercentProfitRequired * AccountBalance() / 100))
		return(true);
	
	return(false);
}


bool AddToPosition(int op)
{
   	string fn = "AddToPosition()";

	AcquireTDI_Values();
	
	if (op == OP_BUY)
		if (Green_1 > 50.0 && Green_1 < 68.0 && Green_1 > BlueH_1)
			return(true);

	if (op == OP_SELL)
		if (Green_1 < 50.0 && Green_1 > 32.0 && Green_1 < BlueL_1)
			return(true);
			
	return(false);
}


//=============================================================================
//
// PURPOSE: 
//     Check to see that it is okay to place a trade right now
//     (See "TRADING TIMES OPTIONS" section of settings for options)
//
// RETURN VALUE:
//      True: Okay to trade right now
//     False: Forbidden to place a new trade at this time
//
//=============================================================================
bool TradingOkay()
{
   	string fn = "TradingOkay()";

	datetime curTime = TimeCurrent();
	
	// Deal with time constraints	
	if (UseTradingTimes == false)
		return(true);
	
	if (Session1Start != "99:99"  &&  Session1End != "99:99"  &&  
		CheckTimes(Session1Start, Session1End))
		return(true);

	if (Session2Start != "99:99"  &&  Session2End != "99:99"  &&  
		CheckTimes(Session2Start, Session2End))
		return(true);

	if (Session3Start != "99:99"  &&  Session3End != "99:99"  &&  
		CheckTimes(Session3Start, Session3End))
		return(true);

	return(false);
}

bool CheckTimes(string start, string end) 
{
	// Check for specific time, return true, if current time is within this range.
	if (IsPast(start) && !IsPast(end)) 
		return(true);
	else 
		return(false);
}


//=============================================================================
//
// PURPOSE: 
//     Provide a shortcut for use of DU_Log where the candle time will be 
//     printed only once, and only if there is debug info during that run.
//     Must set "CandleAnnounced" back to false at the end of start()
//
//=============================================================================
void Debug(int priority, string funcName, string str)
{
	if (priority > DebugLevel)
		return;

	if (!CandleAnnounced)
	{
		DU_Log(1, "Synergy EA", "");
		DU_Log(1, "Synergy EA", "");
		DU_Log(1, "Synergy EA", "");
		DU_Log(1, "Synergy EA", sp30 + "|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||");
		DU_Log(1, "Synergy EA", sp40 + "NEW CANDLE  -  " + TimeToStr(TimeCurrent(), TIME_DATE|TIME_MINUTES|TIME_SECONDS));
		DU_Log(1, "Synergy EA", sp30 + "|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||");
		CandleAnnounced = true;
	}	
	DU_Log(priority, funcName, sp30 + str);
}


//=================================================================================================
//	Expert start function
//=================================================================================================
int start()
{
   	string fn = "Synergy start()";

	int 	ticket, openPos, exitPos, entryDir;
	double	lotsMM;
	bool	NewCandle = IsNewCandle();
	
	// Tasks to perform on each tick ==============================================================
	NumOpenL = NumOpenPositions(MagicNumber, OP_BUY);
	NumOpenS = NumOpenPositions(MagicNumber, OP_SELL);

	// Set up some vars based on whether we're in a trade
	CurTradeDir = -1;
	if (NumOpenL > 0)	CurTradeDir = OP_BUY;
	else 
	if (NumOpenS > 0)	CurTradeDir = OP_SELL;	
	if (CurTradeDir == -1)
		LastLots = 0;
	
	// Handle trailing stop -------------------------------------------------------------
	if (TrailingType > 0)
		if (NumOpenL + NumOpenS > 0)
			AdjTrailOnAllOrders(TrailingType, TrailingValue, MagicNumber, OP_BOTH, 
								FirstMove, FirstSL, SecondMove, SecondSL, ThirdMove);

	// Handle variable TP exit ----------------------------------------------------------
	if (UseATR_Exit)
	{
		exitPos = CheckExitOnATR();
		if (exitPos != -1)
		{
			DoExit(exitPos);
			Debug(1, fn, "");
			Debug(1, fn, ">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>");
			Debug(1, fn, "                                  EXITING ON ATR         ");
			Debug(1, fn, "<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<");
			Debug(1, fn, "");
		}
	}

	// Check for other exit signals once per candle -------------------------------------
	Spread = Ask - Bid;
	if (NewCandle)
	{
		OkToAddPositions = true;
		
		// Check for exit signals based on current trade direction
		if (CheckExitSignals(CurTradeDir))
		{
			Debug(1, fn, "");
			Debug(1, fn, "**._.**._.**._.**._.**");
			Debug(1, fn, sp15 + "Got signal to EXIT " + OrderType2String(CurTradeDir) + " : " + ExitReason);
			Debug(1, fn, "**._.**._.**._.**._.**");
			Debug(1, fn, "");
			if (ExitReason != "OC")
			{
			DoAlert("Synergy: Exit " + OrderType2String(CurTradeDir) + " Signal: " + ExitReason);
			}
			DoExit(OP_BUY);
		}
	}
		

	// Check for entry signals ====================================================================
	
	if (!HandleExitsOnly)
	{
		if (NewCandle || CheckClosedCandle == 0)
		{
			entryDir = CheckEntrySignals();
			
			if (entryDir != -1)
			{
				// Enter new trade if applicable...
				if (CurTradeDir != entryDir)
				{
					// First make sure we are not in any opposite trades
					DoExit(Opp(entryDir));

					SetAdjustedStoplossValue(entryDir);	// Calculate initial stoploss
					lotsMM = CalcLots(MagicNumber);		// Calc the lots to use
					LastLots = lotsMM;
					GlobalVariableSet("QRSX_LastLots", LastLots);

					// Open new position(s)
					if (SplitOrder)
					{
						lotsMM = NormalizeDouble(lotsMM/2, 2);
						DoEntry(entryDir, lotsMM, AdjStopLoss, 0);
					}
					ticket = DoEntry(entryDir, lotsMM, AdjStopLoss, TakeProfit);

					if (ticket != -1)
					{
						CurTradeDir = entryDir;
						LastTradeDir = entryDir;
						LastTicketNum = ticket;
						GlobalVariableSet("QRSX_LastTradeDir", LastTradeDir);
						GlobalVariableSet("QRSX_LastTicketNum", LastTicketNum);
					}
					DoAlert(TimeToStr(TimeCurrent(), TIME_DATE|TIME_MINUTES) + ": " + OrderType2String(entryDir) + " " + Symbol() + " @ " + Ask);
				}
			
				// Add to existing trade if applicable...
				else
				{
					if (AddToPosition(entryDir) && LastLots > 0)
					{
						// Add to position if we already have one open in this direction
						openPos = NumOpenPositions(MagicNumber, entryDir);
						if (openPos > 0 && openPos <= MaxScaleIns && OkToAddPositions)
						{
							SetAdjustedStoplossValue(entryDir);	// Calculate initial stoploss
							lotsMM = NormalizeDouble((LastLots * ScaleInPercent / 100), 2);
							DoEntry(entryDir, lotsMM, AdjStopLoss, TakeProfit);
							OkToAddPositions = false;
						}

						DoAlert(TimeToStr(TimeCurrent(), TIME_DATE|TIME_MINUTES) + ": [Add to] " + OrderType2String(entryDir) + " " + Symbol() + " @ " + Ask);
					}
				}
			}
		}
	}

	// Reset these for the next run through
	HA_ValuesAcquired = false;
	TDI_ValuesAcquired = false;
	PAC_ValuesAcquired = false;
	CandleAnnounced = false;
	return(0);
}

